/* application-window.vala
 *
 * Copyright © 2017 Canek Peláez Valdés
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *    Canek Peláez Valdés <canek@ciencias.unam.mx>
 */
namespace Ejemplo {

    /**
     * La clase de la ventana.
     */
    [GtkTemplate(ui = "/mx/unam/ciencias/ejemplo/application-window.ui")]
    public class ApplicationWindow : Gtk.ApplicationWindow {

        /* El hilandero del primer número. */
        [GtkChild]
        private Gtk.SpinButton numero1_spin;
        /* El hilandero del segundo número. */
        [GtkChild]
        private Gtk.SpinButton numero2_spin;
        /* La etiqueta de la suma. */
        [GtkChild]
        private Gtk.Label suma_label;

        /* La aplicación. */
        private Application app;

        /**
         * Construye una nueva ventana.
         * @param application la aplicación.
         */
        public ApplicationWindow(Gtk.Application application) {
            GLib.Object(application: application);
            app = (Application)application;
        }

        /**
         * El usuario actualizó los números.
         */
        [GtkCallback]
        public void on_numeros_changed() {
            app.actualiza(numero1_spin.get_value_as_int(),
                          numero2_spin.get_value_as_int());
        }

        /**
         * El usuario pide la suma.
         */
        [GtkCallback]
        public void on_suma_clicked() {
            int suma = app.suma();
            suma_label.set_label("%d".printf(suma));
        }
    }
}
