/* application.vala
 *
 * Copyright © 2017 Canek Peláez Valdés
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *    Canek Peláez Valdés <canek@ciencias.unam.mx>
 */
namespace Ejemplo {

    /**
     * Clase para la aplicación de ejemplo.
     */
    public class Application : Gtk.Application {

        /* La ventana. */
        private ApplicationWindow window;
        /* El sumador. */
        private Mat.Sumador sumador;

        /**
         * Construye la aplicación.
         */
        public Application () {
            application_id = "mx.unam.ciencias.ejemplo";
            sumador = new Mat.Sumador();
        }

        /**
         * Activa la aplicación.
         */
        public override void activate () {
            window = new ApplicationWindow (this);
            window.present ();
        }

        /**
         * Actualiza los números.
         * @param numero1 el primer número.
         * @param numero2 el segundo número.
         */
        public void actualiza(int numero1, int numero2) {
            sumador.numero1 = numero1;
            sumador.numero2 = numero2;
        }

        /**
         * Realiza la suma con el sumador.
         * @return la suma de los números.
         */
        public int suma() {
            return sumador.suma();
        }
    }
}
